# uldnames.h File Reference

C++ API: Provides display names of Locale ids and their components. More...

`#include "unicode/utypes.h"`
`#include "unicode/localpointer.h"`
`#include "unicode/uscript.h"`

Go to the source code of this file.

## Typedefs
typedef struct ULocaleDisplayNames | ULocaleDisplayNames
| C typedef for struct ULocaleDisplayNames.
## Enumerations
enum | UDialectHandling { ULDN_STANDARD_NAMES = 0, ULDN_DIALECT_NAMES }
| Enum used in LocaleDisplayNames::createInstance. More...
## Functions
ULocaleDisplayNames * | uldn_open (const char *locale, UDialectHandling dialectHandling, UErrorCode *pErrorCode)
| Returns an instance of LocaleDisplayNames that returns names formatted for the provided locale, using the provided dialectHandling.
void | uldn_close (ULocaleDisplayNames *ldn)
| Closes a ULocaleDisplayNames instance obtained from uldn_open().
const char * | uldn_getLocale (const ULocaleDisplayNames *ldn)
| Returns the locale used to determine the display names.
UDialectHandling | uldn_getDialectHandling (const ULocaleDisplayNames *ldn)
| Returns the dialect handling used in the display names.
int32_t | uldn_localeDisplayName (const ULocaleDisplayNames *ldn, const char *locale, UChar *result, int32_t maxResultSize, UErrorCode *pErrorCode)
| Returns the display name of the provided locale.
int32_t | uldn_languageDisplayName (const ULocaleDisplayNames *ldn, const char *lang, UChar *result, int32_t maxResultSize, UErrorCode *pErrorCode)
| Returns the display name of the provided language code.
int32_t | uldn_scriptDisplayName (const ULocaleDisplayNames *ldn, const char *script, UChar *result, int32_t maxResultSize, UErrorCode *pErrorCode)
| Returns the display name of the provided script.
int32_t | uldn_scriptCodeDisplayName (const ULocaleDisplayNames *ldn, UScriptCode scriptCode, UChar *result, int32_t maxResultSize, UErrorCode *pErrorCode)
| Returns the display name of the provided script code.
int32_t | uldn_regionDisplayName (const ULocaleDisplayNames *ldn, const char *region, UChar *result, int32_t maxResultSize, UErrorCode *pErrorCode)
| Returns the display name of the provided region code.
int32_t | uldn_variantDisplayName (const ULocaleDisplayNames *ldn, const char *variant, UChar *result, int32_t maxResultSize, UErrorCode *pErrorCode)
| Returns the display name of the provided variant.
int32_t | uldn_keyDisplayName (const ULocaleDisplayNames *ldn, const char *key, UChar *result, int32_t maxResultSize, UErrorCode *pErrorCode)
| Returns the display name of the provided locale key.
int32_t | uldn_keyValueDisplayName (const ULocaleDisplayNames *ldn, const char *key, const char *value, UChar *result, int32_t maxResultSize, UErrorCode *pErrorCode)
| Returns the display name of the provided value (used with the provided key).

## Detailed Description

C++ API: Provides display names of Locale ids and their components.

Definition in file uldnames.h.

## Typedef Documentation

typedef struct ULocaleDisplayNames ULocaleDisplayNames

C typedef for struct ULocaleDisplayNames.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Definition at line 49 of file uldnames.h.

## Enumeration Type Documentation

enum UDialectHandling

Enum used in LocaleDisplayNames::createInstance.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

Enumerator:

  ULDN_STANDARD_NAMES | Use standard names when generating a locale name, e.g. en_GB displays as 'English (United Kingdom)'. Draft: This API may be changed in the future versions and was introduced in ICU 4.4
  ULDN_DIALECT_NAMES | Use dialect names, when generating a locale name, e.g. en_GB displays as 'British English'. Draft: This API may be changed in the future versions and was introduced in ICU 4.4

Definition at line 24 of file uldnames.h.

## Function Documentation

void uldn_close | ( | ULocaleDisplayNames * | ldn | ) |

Closes a ULocaleDisplayNames instance obtained from uldn_open().

Parameters:

  | ldn | the ULocaleDisplayNames instance to be closed

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

UDialectHandling uldn_getDialectHandling | ( | const ULocaleDisplayNames * | ldn | ) |

Returns the dialect handling used in the display names.

Parameters:

  | ldn | the LocaleDisplayNames instance

Returns:
  the dialect handling enum

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

const char* uldn_getLocale | ( | const ULocaleDisplayNames * | ldn | ) |

Returns the locale used to determine the display names.

This is not necessarily the same locale passed to uldn_open.

Parameters:

  | ldn | the LocaleDisplayNames instance

Returns:
  the display locale

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

int32_t uldn_keyDisplayName | ( | const ULocaleDisplayNames * | ldn,
|  | const char * | key,
|  | UChar * | result,
|  | int32_t | maxResultSize,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Returns the display name of the provided locale key.

Parameters:

  | ldn | the LocaleDisplayNames instance
  | key | the locale key whose display name to return
  | result | receives the display name
  | maxResultSize | the size of the result buffer
  | pErrorCode | the status code

Returns:
  the actual buffer size needed for the display name. If it's greater than maxResultSize, the returned name will be truncated.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

int32_t uldn_keyValueDisplayName | ( | const ULocaleDisplayNames * | ldn,
|  | const char * | key,
|  | const char * | value,
|  | UChar * | result,
|  | int32_t | maxResultSize,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Returns the display name of the provided value (used with the provided key).

Parameters:

  | ldn | the LocaleDisplayNames instance
  | key | the locale key
  | value | the locale key's value
  | result | receives the display name
  | maxResultSize | the size of the result buffer
  | pErrorCode | the status code

Returns:
  the actual buffer size needed for the display name. If it's greater than maxResultSize, the returned name will be truncated.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

int32_t uldn_languageDisplayName | ( | const ULocaleDisplayNames * | ldn,
|  | const char * | lang,
|  | UChar * | result,
|  | int32_t | maxResultSize,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Returns the display name of the provided language code.

Parameters:

  | ldn | the LocaleDisplayNames instance
  | lang | the language code whose display name to return
  | result | receives the display name
  | maxResultSize | the size of the result buffer
  | pErrorCode | the status code

Returns:
  the actual buffer size needed for the display name. If it's greater than maxResultSize, the returned name will be truncated.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

int32_t uldn_localeDisplayName | ( | const ULocaleDisplayNames * | ldn,
|  | const char * | locale,
|  | UChar * | result,
|  | int32_t | maxResultSize,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Returns the display name of the provided locale.

Parameters:

  | ldn | the LocaleDisplayNames instance
  | locale | the locale whose display name to return
  | result | receives the display name
  | maxResultSize | the size of the result buffer
  | pErrorCode | the status code

Returns:
  the actual buffer size needed for the display name. If it's greater than maxResultSize, the returned name will be truncated.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

ULocaleDisplayNames* uldn_open | ( | const char * | locale,
|  | UDialectHandling | dialectHandling,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Returns an instance of LocaleDisplayNames that returns names formatted for the provided locale, using the provided dialectHandling.

The usual value for dialectHandling is ULOC_STANDARD_NAMES.

Parameters:

  | locale | the display locale
  | dialectHandling | how to select names for locales

Returns:
  a ULocaleDisplayNames instance

Parameters:

  | pErrorCode | the status code

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

int32_t uldn_regionDisplayName | ( | const ULocaleDisplayNames * | ldn,
|  | const char * | region,
|  | UChar * | result,
|  | int32_t | maxResultSize,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Returns the display name of the provided region code.

Parameters:

  | ldn | the LocaleDisplayNames instance
  | region | the region code whose display name to return
  | result | receives the display name
  | maxResultSize | the size of the result buffer
  | pErrorCode | the status code

Returns:
  the actual buffer size needed for the display name. If it's greater than maxResultSize, the returned name will be truncated.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

int32_t uldn_scriptCodeDisplayName | ( | const ULocaleDisplayNames * | ldn,
|  | UScriptCode | scriptCode,
|  | UChar * | result,
|  | int32_t | maxResultSize,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Returns the display name of the provided script code.

Parameters:

  | ldn | the LocaleDisplayNames instance
  | scriptCode | the script code whose display name to return
  | result | receives the display name
  | maxResultSize | the size of the result buffer
  | pErrorCode | the status code

Returns:
  the actual buffer size needed for the display name. If it's greater than maxResultSize, the returned name will be truncated.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

int32_t uldn_scriptDisplayName | ( | const ULocaleDisplayNames * | ldn,
|  | const char * | script,
|  | UChar * | result,
|  | int32_t | maxResultSize,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Returns the display name of the provided script.

Parameters:

  | ldn | the LocaleDisplayNames instance
  | script | the script whose display name to return
  | result | receives the display name
  | maxResultSize | the size of the result buffer
  | pErrorCode | the status code

Returns:
  the actual buffer size needed for the display name. If it's greater than maxResultSize, the returned name will be truncated.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

int32_t uldn_variantDisplayName | ( | const ULocaleDisplayNames * | ldn,
|  | const char * | variant,
|  | UChar * | result,
|  | int32_t | maxResultSize,
|  | UErrorCode * | pErrorCode |
| ) |  |  |

Returns the display name of the provided variant.

Parameters:

  | ldn | the LocaleDisplayNames instance
  | variant | the variant whose display name to return
  | result | receives the display name
  | maxResultSize | the size of the result buffer
  | pErrorCode | the status code

Returns:
  the actual buffer size needed for the display name. If it's greater than maxResultSize, the returned name will be truncated.

Draft:
  This API may be changed in the future versions and was introduced in ICU 4.4

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Friends Defines